
#ifndef __DATA_H__INCLUDED__
#define __DATA_H__INCLUDED__


#define PALDATA_FIX                         0
#define PALDATA_SELGUAGE                    1
#define PALDATA_POWERMETERSELECT            2
#define PALDATA_VIXEN0                      3
#define PALDATA_VIXEN0B                     4
#define PALDATA_VIXEN1                      5
#define PALDATA_VIXEN1B                     6
#define PALDATA_VIXEN2                      7
#define PALDATA_VIXEN2B                     8
#define PALDATA_VIXEN3                      9
#define PALDATA_VIXEN3B                     10
#define PALDATA_MISSILE0                    11
#define PALDATA_MISSILE1                    12
#define PALDATA_MISSILE2                    13
#define PALDATA_MISSILE3                    14
#define PALDATA_MULTIPLE0                   15
#define PALDATA_MULTIPLE1                   16
#define PALDATA_MULTIPLE2                   17
#define PALDATA_SHIELD0                     18
#define PALDATA_SHIELD1                     19
#define PALDATA_SHIELD2                     20
#define PALDATA_SHIELD3                     21
#define PALDATA_EXPLOSION0                  22
#define PALDATA_SELECTWEAPON                23
#define PALDATA_ARTIFICIALSUN0              24
#define PALDATA_ARTIFICIALSUN1              25
#define PALDATA_ARTIFICIALSUN2              26
#define PALDATA_ARTIFICIALSUN3              27
#define PALDATA_ARTIFICIALSUN4              28
#define PALDATA_BOSS0_0                     29
#define PALDATA_BOSS0_1                     30
#define PALDATA_BOSS0_2                     31

#define CHRDATA_FIX_OFFSET                  0
#define CHRDATA_FIX_COUNT                   256
#define CHRDATA_POWERMETERSELECT_OFFSET     256
#define CHRDATA_POWERMETERSELECT_COUNT      240
#define CHRDATA_ARTIFICIALSUN_OFFSET        496
#define CHRDATA_ARTIFICIALSUN_COUNT         112
#define CHRDATA_ARTIFICIALSUN0_OFFSET       608
#define CHRDATA_ARTIFICIALSUN0_COUNT        60
#define CHRDATA_ARTIFICIALSUN1_OFFSET       668
#define CHRDATA_ARTIFICIALSUN1_COUNT        60
#define CHRDATA_ARTIFICIALSUN2_OFFSET       728
#define CHRDATA_ARTIFICIALSUN2_COUNT        60
#define CHRDATA_ARTIFICIALSUN3_OFFSET       788
#define CHRDATA_ARTIFICIALSUN3_COUNT        60
#define CHRDATA_SELECTWEAPON_OFFSET         848
#define CHRDATA_SELECTWEAPON_COUNT          176
#define CHRDATA_VIXEN0_OFFSET               1024
#define CHRDATA_VIXEN0_COUNT                40
#define CHRDATA_VIXEN1_OFFSET               1064
#define CHRDATA_VIXEN1_COUNT                40
#define CHRDATA_VIXEN2_OFFSET               1104
#define CHRDATA_VIXEN2_COUNT                40
#define CHRDATA_VIXEN3_OFFSET               1144
#define CHRDATA_VIXEN3_COUNT                40
#define CHRDATA_MULTIPLE0_OFFSET            1184
#define CHRDATA_MULTIPLE0_COUNT             12
#define CHRDATA_MULTIPLE1_OFFSET            1196
#define CHRDATA_MULTIPLE1_COUNT             12
#define CHRDATA_MULTIPLE2_OFFSET            1208
#define CHRDATA_MULTIPLE2_COUNT             12
#define CHRDATA_BEAM0_OFFSET                1220
#define CHRDATA_BEAM0_COUNT                 8
#define CHRDATA_BEAM1_OFFSET                1228
#define CHRDATA_BEAM1_COUNT                 8
#define CHRDATA_BEAM2_OFFSET                1236
#define CHRDATA_BEAM2_COUNT                 8
#define CHRDATA_MISSILE_OFFSET              1244
#define CHRDATA_MISSILE_COUNT               20
#define CHRDATA_PHOTONMISSILE_OFFSET        1264
#define CHRDATA_PHOTONMISSILE_COUNT         20
#define CHRDATA_NAPALMMISSILE_OFFSET        1284
#define CHRDATA_NAPALMMISSILE_COUNT         20
#define CHRDATA_NAPALMEXPLOSION_OFFSET      1304
#define CHRDATA_NAPALMEXPLOSION_COUNT       20
#define CHRDATA_TWOWAYMISSILE_OFFSET        1324
#define CHRDATA_TWOWAYMISSILE_COUNT         20
#define CHRDATA_UPDOUBLE0_OFFSET            1344
#define CHRDATA_UPDOUBLE0_COUNT             8
#define CHRDATA_UPDOUBLE1_OFFSET            1352
#define CHRDATA_UPDOUBLE1_COUNT             8
#define CHRDATA_TAILBEAM0_OFFSET            1360
#define CHRDATA_TAILBEAM0_COUNT             16
#define CHRDATA_TAILBEAM1_OFFSET            1376
#define CHRDATA_TAILBEAM1_COUNT             16
#define CHRDATA_LASER0_OFFSET               1392
#define CHRDATA_LASER0_COUNT                24
#define CHRDATA_LASER1_OFFSET               1416
#define CHRDATA_LASER1_COUNT                24
#define CHRDATA_RIPPLELASER_OFFSET          1440
#define CHRDATA_RIPPLELASER_COUNT           32
#define CHRDATA_SHIELD_OFFSET               1472
#define CHRDATA_SHIELD_COUNT                80
#define CHRDATA_FORCEFIELD_OFFSET           1552
#define CHRDATA_FORCEFIELD_COUNT            96
#define CHRDATA_POWERCAPSULE0_OFFSET        1648
#define CHRDATA_POWERCAPSULE0_COUNT         16
#define CHRDATA_POWERCAPSULE1_OFFSET        1664
#define CHRDATA_POWERCAPSULE1_COUNT         16
#define CHRDATA_POWERCAPSULE2_OFFSET        1680
#define CHRDATA_POWERCAPSULE2_COUNT         16
#define CHRDATA_EFFECT00_OFFSET             1696
#define CHRDATA_EFFECT00_COUNT              16
#define CHRDATA_EXPLOSIONVIXEN0_OFFSET      1712
#define CHRDATA_EXPLOSIONVIXEN0_COUNT       20
#define CHRDATA_EXPLOSIONVIXEN1_OFFSET      1732
#define CHRDATA_EXPLOSIONVIXEN1_COUNT       40
#define CHRDATA_EXPLOSION00_OFFSET          1772
#define CHRDATA_EXPLOSION00_COUNT           12
#define CHRDATA_EXPLOSION01_OFFSET          1784
#define CHRDATA_EXPLOSION01_COUNT           16
#define CHRDATA_BULLET00_OFFSET             1800
#define CHRDATA_BULLET00_COUNT              8
#define CHRDATA_ENEMY00_OFFSET              1808
#define CHRDATA_ENEMY00_COUNT               96
#define CHRDATA_ENEMY01_OFFSET              1904
#define CHRDATA_ENEMY01_COUNT               16
#define CHRDATA_ENEMY02_OFFSET              1920
#define CHRDATA_ENEMY02_COUNT               360
#define CHRDATA_BOSS0_0_OFFSET              2280
#define CHRDATA_BOSS0_0_COUNT               44
#define CHRDATA_BOSS0_1_OFFSET              2324
#define CHRDATA_BOSS0_1_COUNT               20
#define CHRDATA_BOSS0_2_OFFSET              2344
#define CHRDATA_BOSS0_2_COUNT               12

#define XFERDATA_FIX_OFFSET                 0
#define XFERDATA_FIX_COUNT                  2
#define XFERDATA_VIXEN_OFFSET               2
#define XFERDATA_VIXEN_COUNT                1
#define XFERDATA_BEAM_OFFSET                3
#define XFERDATA_BEAM_COUNT                 1
#define XFERDATA_NAPALMMISSILE_OFFSET       4
#define XFERDATA_NAPALMMISSILE_COUNT        1
#define XFERDATA_TAILBEAM_OFFSET            5
#define XFERDATA_TAILBEAM_COUNT             1
#define XFERDATA_RIPPLELASER_OFFSET         6
#define XFERDATA_RIPPLELASER_COUNT          1
#define XFERDATA_MULTIPLE_OFFSET            7
#define XFERDATA_MULTIPLE_COUNT             1
#define XFERDATA_SHIELD_OFFSET              8
#define XFERDATA_SHIELD_COUNT               1
#define XFERDATA_FORCEFIELD_OFFSET          9
#define XFERDATA_FORCEFIELD_COUNT           1
#define XFERDATA_POWERCAPSULE_OFFSET        10
#define XFERDATA_POWERCAPSULE_COUNT         1
#define XFERDATA_EXPLOSIONVIXEN_OFFSET      11
#define XFERDATA_EXPLOSIONVIXEN_COUNT       1
#define XFERDATA_GAME_OFFSET                12
#define XFERDATA_GAME_COUNT                 2
#define XFERDATA_VIXEN0_OFFSET              14
#define XFERDATA_VIXEN0_COUNT               13
#define XFERDATA_VIXEN1_OFFSET              27
#define XFERDATA_VIXEN1_COUNT               14
#define XFERDATA_VIXEN2_OFFSET              41
#define XFERDATA_VIXEN2_COUNT               14
#define XFERDATA_VIXEN3_OFFSET              55
#define XFERDATA_VIXEN3_COUNT               14
#define XFERDATA_POWERMETERSELECT_OFFSET    69
#define XFERDATA_POWERMETERSELECT_COUNT     5
#define XFERDATA_STAGE1_OFFSET              74
#define XFERDATA_STAGE1_COUNT               10

#define PALPOS_FIX                          0
#define PALPOS_SELGUAGE                     1
#define CHRPOS_FIX                          0
#define CHRPOS_VIXEN                        1024
#define CHRPOS_BEAM                         1064
#define CHRPOS_NAPALMMISSILE                1072
#define CHRPOS_NAPALMEXPLOSION              1092
#define CHRPOS_TAILBEAM                     1112
#define CHRPOS_RIPPLELASER                  1128
#define CHRPOS_MULTIPLE                     1160
#define CHRPOS_SHIELD                       1172
#define CHRPOS_FORCEFIELD                   1252
#define CHRPOS_POWERCAPSULE                 1348
#define CHRPOS_EXPLOSIONVIXEN               1364
#define CHRPOS_EFFECT00                     1404
#define CHRPOS_EXPLOSION00                  1420
#define CHRPOS_EXPLOSION01                  1432
#define CHRPOS_BULLET00                     1448
#define PALPOS_VIXEN                        2
#define PALPOS_MISSILE                      3
#define PALPOS_MULTIPLE                     4
#define PALPOS_SHIELD                       5
#define PALPOS_VIXENB                       16
#define CHRPOS_MISSILE                      1072
#define CHRPOS_UPDOUBLE                     1112
#define CHRPOS_LASER                        1128
#define CHRPOS_PHOTONMISSILE                1072
#define CHRPOS_TWOWAYMISSILE                1072
#define PALPOS_SELECTWEAPON                 6
#define PALPOS_POWERMETERSELECT             7
#define PALPOS_POWERMETERSELECTB            17
#define CHRPOS_POWERMETERSELECT             256
#define CHRPOS_SELECTWEAPON                 1404
#define PALPOS_EXPLOSION0                   6
#define PALPOS_ARTIFICIALSUN                7
#define PALPOS_BOSS0_0                      8
#define PALPOS_BOSS0_1                      9
#define PALPOS_ARTIFICIALSUN0               24
#define PALPOS_ARTIFICIALSUN1               25
#define PALPOS_ARTIFICIALSUN2               26
#define PALPOS_ARTIFICIALSUN3               27
#define PALPOS_ARTIFICIALSUN4               28
#define PALPOS_BOSS0_2                      29
#define CHRPOS_ARTIFICIALSUN                368
#define CHRPOS_ARTIFICIALSUN0               428
#define CHRPOS_ARTIFICIALSUN1               488
#define CHRPOS_ARTIFICIALSUN2               548
#define CHRPOS_ARTIFICIALSUN3               608
#define CHRPOS_BOSS0_0                      768
#define CHRPOS_ENEMY00                      1456
#define CHRPOS_ENEMY01                      1552
#define CHRPOS_ENEMY02                      1568
#define CHRPOS_BOSS0_1                      1928
#define CHRPOS_BOSS0_2                      1948

#define PAT_BLANK                           0
#define PAT_WEAPON_TYPEL                    1
#define PAT_WEAPON_TYPER                    2
#define PAT_WEAPON_TYPE1                    3
#define PAT_WEAPON_TYPE2                    4
#define PAT_WEAPON_TYPE3                    5
#define PAT_WEAPON_TYPE4                    6
#define PAT_VIXEN0                          7
#define PAT_VIXEN1                          8
#define PAT_VIXEN2                          9
#define PAT_VIXEN3                          10
#define PAT_VIXEN4                          11
#define PAT_MULTIPLE0                       12
#define PAT_MULTIPLE1                       13
#define PAT_MULTIPLE2                       14
#define PAT_BEAM0                           15
#define PAT_BEAM1                           16
#define PAT_MISSILE0                        17
#define PAT_MISSILE1                        18
#define PAT_MISSILE2                        19
#define PAT_MISSILE3                        20
#define PAT_MISSILE4                        21
#define PAT_PHOTONMISSILE0                  22
#define PAT_PHOTONMISSILE1                  23
#define PAT_PHOTONMISSILE2                  24
#define PAT_PHOTONMISSILE3                  25
#define PAT_PHOTONMISSILE4                  26
#define PAT_NAPALMMISSILE0                  27
#define PAT_NAPALMMISSILE1                  28
#define PAT_NAPALMMISSILE2                  29
#define PAT_NAPALMMISSILE3                  30
#define PAT_NAPALMMISSILE4                  31
#define PAT_NAPALMEXPLOSION0                32
#define PAT_NAPALMEXPLOSION1                33
#define PAT_NAPALMEXPLOSION2                34
#define PAT_NAPALMEXPLOSION3                35
#define PAT_NAPALMEXPLOSION4                36
#define PAT_TWOWAYMISSILEU0                 37
#define PAT_TWOWAYMISSILEU1                 38
#define PAT_TWOWAYMISSILEU2                 39
#define PAT_TWOWAYMISSILEU3                 40
#define PAT_TWOWAYMISSILEU4                 41
#define PAT_TWOWAYMISSILED0                 42
#define PAT_TWOWAYMISSILED1                 43
#define PAT_TWOWAYMISSILED2                 44
#define PAT_TWOWAYMISSILED3                 45
#define PAT_TWOWAYMISSILED4                 46
#define PAT_UPDOUBLE0                       47
#define PAT_UPDOUBLE1                       48
#define PAT_TAILBEAM0                       49
#define PAT_TAILBEAM1                       50
#define PAT_TAILBEAM2                       51
#define PAT_TAILBEAM3                       52
#define PAT_LASER0                          53
#define PAT_LASER1                          54
#define PAT_LASER_EFFECT0                   55
#define PAT_LASER_EFFECT1                   56
#define PAT_LASER_EFFECT2                   57
#define PAT_LASER_EFFECT3                   58
#define PAT_RIPPLELASER0                    59
#define PAT_RIPPLELASER1                    60
#define PAT_RIPPLELASER2                    61
#define PAT_RIPPLELASER3                    62
#define PAT_RIPPLELASER4                    63
#define PAT_RIPPLELASER5                    64
#define PAT_SHIELDU0_0                      65
#define PAT_SHIELDU0_1                      66
#define PAT_SHIELDU0_2                      67
#define PAT_SHIELDU0_3                      68
#define PAT_SHIELDU1_0                      69
#define PAT_SHIELDU1_1                      70
#define PAT_SHIELDU1_2                      71
#define PAT_SHIELDU1_3                      72
#define PAT_SHIELDU2_0                      73
#define PAT_SHIELDU2_1                      74
#define PAT_SHIELDU2_2                      75
#define PAT_SHIELDU2_3                      76
#define PAT_SHIELDU3_0                      77
#define PAT_SHIELDU3_1                      78
#define PAT_SHIELDU3_2                      79
#define PAT_SHIELDU3_3                      80
#define PAT_SHIELDU4_0                      81
#define PAT_SHIELDU4_1                      82
#define PAT_SHIELDU4_2                      83
#define PAT_SHIELDU4_3                      84
#define PAT_SHIELDD0_0                      85
#define PAT_SHIELDD0_1                      86
#define PAT_SHIELDD0_2                      87
#define PAT_SHIELDD0_3                      88
#define PAT_SHIELDD1_0                      89
#define PAT_SHIELDD1_1                      90
#define PAT_SHIELDD1_2                      91
#define PAT_SHIELDD1_3                      92
#define PAT_SHIELDD2_0                      93
#define PAT_SHIELDD2_1                      94
#define PAT_SHIELDD2_2                      95
#define PAT_SHIELDD2_3                      96
#define PAT_SHIELDD3_0                      97
#define PAT_SHIELDD3_1                      98
#define PAT_SHIELDD3_2                      99
#define PAT_SHIELDD3_3                      100
#define PAT_SHIELDD4_0                      101
#define PAT_SHIELDD4_1                      102
#define PAT_SHIELDD4_2                      103
#define PAT_SHIELDD4_3                      104
#define PAT_FORCEFIELD0                     105
#define PAT_FORCEFIELD1                     106
#define PAT_FORCEFIELD2                     107
#define PAT_FORCEFIELD3                     108
#define PAT_POWERCAPSULE0                   109
#define PAT_POWERCAPSULE1                   110
#define PAT_POWERCAPSULE2                   111
#define PAT_POWERCAPSULE3                   112
#define PAT_EFFECT00_0                      113
#define PAT_EFFECT00_1                      114
#define PAT_EFFECT00_2                      115
#define PAT_EFFECT00_3                      116
#define PAT_EXPLOSIONVIXEN0_0               117
#define PAT_EXPLOSIONVIXEN0_1               118
#define PAT_EXPLOSIONVIXEN0_2               119
#define PAT_EXPLOSIONVIXEN0_3               120
#define PAT_EXPLOSIONVIXEN0_4               121
#define PAT_EXPLOSIONVIXEN1_0               122
#define PAT_EXPLOSIONVIXEN1_1               123
#define PAT_EXPLOSIONVIXEN1_2               124
#define PAT_EXPLOSIONVIXEN1_3               125
#define PAT_EXPLOSIONVIXEN1_4               126
#define PAT_EXPLOSION00_0                   127
#define PAT_EXPLOSION00_1                   128
#define PAT_EXPLOSION00_2                   129
#define PAT_EXPLOSION01_0                   130
#define PAT_EXPLOSION01_1                   131
#define PAT_EXPLOSION01_2                   132
#define PAT_EXPLOSION01_3                   133
#define PAT_BULLET00_0                      134
#define PAT_BULLET00_1                      135
#define PAT_ENEMY00_0                       136
#define PAT_ENEMY00_1                       137
#define PAT_ENEMY00_2                       138
#define PAT_ENEMY00_3                       139
#define PAT_ENEMY00_4                       140
#define PAT_ENEMY00_5                       141
#define PAT_ENEMY01_0                       142
#define PAT_ENEMY01_1                       143
#define PAT_ENEMY01_2                       144
#define PAT_ENEMY01_3                       145
#define PAT_ENEMY02U_0                      146
#define PAT_ENEMY02U_1                      147
#define PAT_ENEMY02U_2                      148
#define PAT_ENEMY02U_3                      149
#define PAT_ENEMY02U_4                      150
#define PAT_ENEMY02U_5                      151
#define PAT_ENEMY02U_6                      152
#define PAT_ENEMY02D_0                      153
#define PAT_ENEMY02D_1                      154
#define PAT_ENEMY02D_2                      155
#define PAT_ENEMY02D_3                      156
#define PAT_ENEMY02D_4                      157
#define PAT_ENEMY02D_5                      158
#define PAT_ENEMY02D_6                      159
#define PAT_ENEMY02L_0                      160
#define PAT_ENEMY02L_1                      161
#define PAT_ENEMY02L_2                      162
#define PAT_ENEMY02L_3                      163
#define PAT_ENEMY02L_4                      164
#define PAT_ENEMY02L_5                      165
#define PAT_ENEMY02L_6                      166
#define PAT_ENEMY02R_0                      167
#define PAT_ENEMY02R_1                      168
#define PAT_ENEMY02R_2                      169
#define PAT_ENEMY02R_3                      170
#define PAT_ENEMY02R_4                      171
#define PAT_ENEMY02R_5                      172
#define PAT_ENEMY02R_6                      173
#define PAT_BOSS0_CORE0                     174
#define PAT_BOSS0_CORE1                     175
#define PAT_BOSS0_CORE2                     176
#define PAT_BOSS0_CORE3                     177
#define PAT_BOSS0_CORE4                     178
#define PAT_BOSS0_SHIELD0                   179
#define PAT_BOSS0_SHIELD1                   180
#define PAT_BOSS0_LASER                     181
#define PAT_BOSS0_BODY0                     182
#define PAT_BOSS0_BODY1                     183
#define PAT_BOSS0_BODY2                     184
#define PAT_BOSS0_BODY3                     185
#define PAT_BOSS0_BODY4                     186

#define ACT_MULTIPLE                        0
#define ACT_NAPARMEXPLOSION                 5
#define ACT_BEAM                            11
#define ACT_UPDOUBLE                        14
#define ACT_TAILBEAM0                       17
#define ACT_TAILBEAM1                       20
#define ACT_RIPPLELASER                     23
#define ACT_SHIELDU0                        30
#define ACT_SHIELDU1                        35
#define ACT_SHIELDU2                        40
#define ACT_SHIELDU3                        45
#define ACT_SHIELDU4                        50
#define ACT_SHIELDD0                        55
#define ACT_SHIELDD1                        60
#define ACT_SHIELDD2                        65
#define ACT_SHIELDD3                        70
#define ACT_SHIELDD4                        75
#define ACT_FORCEFIELD0                     80
#define ACT_FORCEFIELD1                     83
#define ACT_POWERCAPSULE                    86
#define ACT_EXPLOSIONVIXEN0                 91
#define ACT_EXPLOSIONVIXEN1                 97
#define ACT_EXPLOSION00                     103
#define ACT_EXPLOSION01                     107
#define ACT_EFFECT00                        112
#define ACT_BULLET00                        117
#define ACT_ENEMY00                         120
#define ACT_ENEMY01                         127
#define ACT_ENEMY02U                        132
#define ACT_ENEMY02D                        151
#define ACT_ENEMY02L                        170
#define ACT_ENEMY02R                        189
#define ACT_BOSS0_CORE0                     208
#define ACT_BOSS0_CORE1                     210
#define ACT_BOSS0_OPENCORE                  212
#define ACT_BOSS0_CLOSECORE                 217

#define BGM_00                              0
#define BGM_01                              1
#define BGM_02                              2
#define BGM_03                              3
#define BGM_10                              4
#define SE_00                               0
#define SE_01                               1
#define SE_02                               2
#define SE_03                               3
#define SE_04                               4
#define SE_05                               5
#define SE_06                               6
#define SE_07                               7
#define SE_08                               8
#define SE_20                               9
#define SE_21                               10
#define SE_22                               11
#define SE_23                               12
#define SE_30                               13
#define SE_31                               14
#define SE_40                               15
#define SE_41                               16
#define SE_42                               17
#define SE_43                               18
#define SE_44                               19
#define SE_45                               20
#define SE_46                               21
#define SE_47                               22
#define SE_48                               23
#define SE_49                               24
#define SE_50                               25
#define SE_51                               26
#define SE_52                               27

extern const uint16_t               g_palData[][16] ;
extern const uint32_t               g_chrData[][8] ;
extern const XFERDATA               g_xferData[] ;
extern const PATDATA                g_patData[] ;
extern const PATINFO                g_patInfo[] ;
extern const uint16_t               g_actData[][2] ;
extern const uint16_t               * const g_p_bgmData[] ;
extern const uint16_t               * const g_p_seData[] ;
extern const STGINFO                g_stgInfo[1] ;


#endif//__DATA_H__INCLUDED__
