#ifndef __DATA_H__INCLUDED__
#define __DATA_H__INCLUDED__


#define PAT_PLAYERU                 0
#define PAT_PLAYER                  1
#define PAT_PLAYERD                 2
#define PAT_PLAYERJET0              3
#define PAT_PLAYERJET1              4
#define PAT_PLAYERJET2              5
#define PAT_BEAM                    6
#define PAT_BEAMUD                  7
#define PAT_BEAMWAVE0               8
#define PAT_BEAMWAVE1_0             9
#define PAT_BEAMWAVE1_1             10
#define PAT_BEAMWAVE2_0             11
#define PAT_BEAMWAVE2_1             12
#define PAT_BEAMWAVE2_2             13
#define PAT_BEAMWAVE3_0             14
#define PAT_BEAMWAVE3_1             15
#define PAT_BEAMWAVE3_2             16
#define PAT_BEAMWAVE3_3             17
#define PAT_MISSILE0_0              18
#define PAT_MISSILE0_1              19
#define PAT_MISSILE1_0              20
#define PAT_MISSILE1_1              21
#define PAT_MISSILE2_0              22
#define PAT_MISSILE2_1              23
#define PAT_MISSILE3_0              24
#define PAT_MISSILE3_1              25
#define PAT_MISSILE4_0              26
#define PAT_MISSILE4_1              27
#define PAT_MISSILE5_0              28
#define PAT_MISSILE5_1              29
#define PAT_MISSILE6_0              30
#define PAT_MISSILE6_1              31
#define PAT_MISSILE7_0              32
#define PAT_MISSILE7_1              33
#define PAT_FORCES0                 34
#define PAT_FORCES1                 35
#define PAT_FORCEM0_R               36
#define PAT_FORCEM1_R               37
#define PAT_FORCEM2_R               38
#define PAT_FORCEL0_R               39
#define PAT_FORCEL1_R               40
#define PAT_FORCEL2_R               41
#define PAT_FORCEM0_L               42
#define PAT_FORCEM1_L               43
#define PAT_FORCEM2_L               44
#define PAT_FORCEL0_L               45
#define PAT_FORCEL1_L               46
#define PAT_FORCEL2_L               47
#define PAT_ATALASER0               48
#define PAT_ATALASER1               49
#define PAT_ATALASER2               50
#define PAT_ATALASER3               51
#define PAT_ATALASER4               52
#define PAT_ATGLASER0               53
#define PAT_ATGLASER1               54
#define PAT_ATGLASER2               55
#define PAT_ATGLASER3               56
#define PAT_BIT0                    57
#define PAT_BIT1                    58
#define PAT_BIT2                    59
#define PAT_BIT3                    60
#define PAT_BITBEAMU0               61
#define PAT_BITBEAMU1               62
#define PAT_BITBEAMU2               63
#define PAT_BITBEAMU3               64
#define PAT_BITBEAMD0               65
#define PAT_BITBEAMD1               66
#define PAT_BITBEAMD2               67
#define PAT_BITBEAMD3               68
#define PAT_ENEMY0_0                69
#define PAT_ENEMY0_1                70
#define PAT_ENEMY0_2                71
#define PAT_ENEMY1_0                72
#define PAT_ENEMY1_1                73
#define PAT_ENEMY1_2                74
#define PAT_ENEMY1_3                75
#define PAT_ENEMY1_4                76
#define PAT_ENEMY1_5                77
#define PAT_ENEMY1_6                78
#define PAT_ENEMY1_7                79
#define PAT_ENEMY2_0                80
#define PAT_ENEMY2_1                81
#define PAT_ENEMY2_2                82
#define PAT_ENEMY2_3                83
#define PAT_ENEMY2_4                84
#define PAT_ENEMY2_5                85
#define PAT_ENEMY2_6                86
#define PAT_ENEMY2_7                87
#define PAT_ENEMY2_8                88

#define ACT_PLAYERJET               0
#define ACT_BEAMWAVE0               1
#define ACT_BEAMWAVE1               2
#define ACT_BEAMWAVE2               3
#define ACT_BEAMWAVE3               4
#define ACT_FORCES_R                5
#define ACT_FORCES_L                6
#define ACT_FORCEM_R                7
#define ACT_FORCEM_L                8
#define ACT_FORCEL_R                9
#define ACT_FORCEL_L                10
#define ACT_ATALASER                11
#define ACT_ATGLASER                12
#define ACT_BIT_U                   13
#define ACT_BIT_D                   14
#define ACT_BITBEAM_RU              15
#define ACT_BITBEAM_LU              16
#define ACT_BITBEAM_RD              17
#define ACT_BITBEAM_LD              18
#define ACT_ENEMY0                  19
#define ACT_ENEMY1_R                20
#define ACT_ENEMY1_D                21
#define ACT_ENEMY1_L                22
#define ACT_ENEMY1_U                23


extern const uint8_t                g_fontData[] ;
extern uint16_t                     g_palData[][16] ;
extern const uint16_t               * const g_p_patData[] ;
extern const uint8_t                * const g_p_actData[] ;
extern const uint16_t               g_mapData[][404] ;
extern const uint8_t                g_enemyData[] ;


#endif//__DATA_H__INCLUDED__
